python/qemu/console_socket.py: Clarify type of drain_thread
[qemu.git] / Makefile
1 # Makefile for QEMU.
2
3 ifneq ($(words $(subst :, ,$(CURDIR))), 1)
4 $(error main directory cannot contain spaces nor colons)
5 endif
6
7 # Always point to the root of the build tree (needs GNU make).
8 BUILD_DIR=$(CURDIR)
9
10 # Before including a proper config-host.mak, assume we are in the source tree
11 SRC_PATH=.
12
13 # Don't use implicit rules or variables
14 # we have explicit rules for everything
15 MAKEFLAGS += -rR
16
17 SHELL = /usr/bin/env bash -o pipefail
18
19 # Usage: $(call quiet-command,command and args,"NAME","args to print")
20 # This will run "command and args", and either:
21 # if V=1 just print the whole command and args
22 # otherwise print the 'quiet' output in the format " NAME args to print"
23 # NAME should be a short name of the command, 7 letters or fewer.
24 # If called with only a single argument, will print nothing in quiet mode.
25 quiet-command-run = $(if $(V),,$(if $2,printf " %-7s %s\n" $2 $3 && ))$1
26 quiet-@ = $(if $(V),,@)
27 quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)
28
29 UNCHECKED_GOALS := %clean TAGS cscope ctags dist \
30 help check-help print-% \
31 docker docker-% vm-help vm-test vm-build-%
32
33 all:
34 .PHONY: all clean distclean recurse-all dist msi FORCE
35
36 # Don't try to regenerate Makefile or configure
37 # We don't generate any of them
38 Makefile: ;
39 configure: ;
40
41 # All following code might depend on configuration variables
42 ifneq ($(wildcard config-host.mak),)
43 include config-host.mak
44
45 git-submodule-update:
46 .git-submodule-status: git-submodule-update config-host.mak
47 Makefile: .git-submodule-status
48
49 .PHONY: git-submodule-update
50
51 git_module_status := $(shell \
52 cd '$(SRC_PATH)' && \
53 GIT="$(GIT)" ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
54 echo $$?; \
55 )
56
57 ifeq (1,$(git_module_status))
58 ifeq (no,$(GIT_UPDATE))
59 git-submodule-update:
60 $(call quiet-command, \
61 echo && \
62 echo "GIT submodule checkout is out of date. Please run" && \
63 echo " scripts/git-submodule.sh update $(GIT_SUBMODULES)" && \
64 echo "from the source directory checkout $(SRC_PATH)" && \
65 echo && \
66 exit 1)
67 else
68 git-submodule-update:
69 $(call quiet-command, \
70 (cd $(SRC_PATH) && GIT="$(GIT)" ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
71 "GIT","$(GIT_SUBMODULES)")
72 endif
73 endif
74
75 # 0. ensure the build tree is okay
76
77 # Check that we're not trying to do an out-of-tree build from
78 # a tree that's been used for an in-tree build.
79 ifneq ($(realpath $(SRC_PATH)),$(realpath .))
80 ifneq ($(wildcard $(SRC_PATH)/config-host.mak),)
81 $(error This is an out of tree build but your source tree ($(SRC_PATH)) \
82 seems to have been used for an in-tree build. You can fix this by running \
83 "$(MAKE) distclean && rm -rf *-linux-user *-softmmu" in your source tree)
84 endif
85 endif
86
87 # force a rerun of configure if config-host.mak is too old or corrupted
88 ifeq ($(MESON),)
89 .PHONY: config-host.mak
90 x := $(shell rm -rf meson-private meson-info meson-logs)
91 endif
92 ifeq ($(NINJA),)
93 .PHONY: config-host.mak
94 x := $(shell rm -rf meson-private meson-info meson-logs)
95 endif
96 ifeq ($(wildcard build.ninja),)
97 .PHONY: config-host.mak
98 x := $(shell rm -rf meson-private meson-info meson-logs)
99 endif
100
101 # 1. ensure config-host.mak is up-to-date
102 config-host.mak: $(SRC_PATH)/configure $(SRC_PATH)/pc-bios $(SRC_PATH)/VERSION
103 @echo $@ is out-of-date, running configure
104 @if test -f meson-private/coredata.dat; then \
105 ./config.status --skip-meson; \
106 else \
107 ./config.status; \
108 fi
109
110 # 2. ensure generated build files are up-to-date
111
112 ifneq ($(NINJA),)
113 # A separate rule is needed for Makefile dependencies to avoid -n
114 export NINJA
115 Makefile.ninja: build.ninja
116 $(quiet-@){ echo 'ninja-targets = \'; $(NINJA) -t targets all | sed 's/:.*//; $$!s/$$/ \\/'; } > $@
117 -include Makefile.ninja
118 endif
119
120 ifneq ($(MESON),)
121 # The dependency on config-host.mak ensures that meson has run
122 Makefile.mtest: build.ninja scripts/mtest2make.py config-host.mak
123 $(MESON) introspect --targets --tests --benchmarks | $(PYTHON) scripts/mtest2make.py > $@
124 -include Makefile.mtest
125 endif
126
127 # 3. Rules to bridge to other makefiles
128
129 ifneq ($(NINJA),)
130 NINJAFLAGS = $(if $V,-v,) \
131 $(filter-out -j, $(lastword -j1 $(filter -l% -j%, $(MAKEFLAGS)))) \
132 $(subst -k, -k0, $(filter -n -k,$(MAKEFLAGS)))
133
134 ninja-cmd-goals = $(or $(MAKECMDGOALS), all)
135 ninja-cmd-goals += $(foreach t, $(.tests), $(.test.deps.$t))
136
137 makefile-targets := build.ninja ctags TAGS cscope dist clean uninstall
138 ninja-targets := $(filter-out $(makefile-targets), $(ninja-targets))
139 .PHONY: $(ninja-targets) run-ninja
140 $(ninja-targets): run-ninja
141
142 # Use "| cat" to give Ninja a more "make-y" output. Use "+" to bypass the
143 # --output-sync line.
144 run-ninja: config-host.mak
145 ifneq ($(filter $(ninja-targets), $(ninja-cmd-goals)),)
146 +@$(NINJA) $(NINJAFLAGS) $(sort $(filter $(ninja-targets), $(ninja-cmd-goals))) | cat
147 endif
148 endif
149
150 # Force configure to re-run if the API symbols are updated
151 ifeq ($(CONFIG_PLUGIN),y)
152 config-host.mak: $(SRC_PATH)/plugins/qemu-plugins.symbols
153
154 .PHONY: plugins
155 plugins:
156 $(call quiet-command,\
157 $(MAKE) $(SUBDIR_MAKEFLAGS) -C contrib/plugins V="$(V)", \
158 "BUILD", "example plugins")
159 endif # $(CONFIG_PLUGIN)
160
161 else # config-host.mak does not exist
162 config-host.mak:
163 ifneq ($(filter-out $(UNCHECKED_GOALS),$(MAKECMDGOALS)),$(if $(MAKECMDGOALS),,fail))
164 @echo "Please call configure before running make!"
165 @exit 1
166 endif
167 endif # config-host.mak does not exist
168
169 SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory --quiet)
170
171 include $(SRC_PATH)/tests/Makefile.include
172
173 all: recurse-all
174
175 ROM_DIRS = $(addprefix pc-bios/, $(ROMS))
176 ROM_DIRS_RULES=$(foreach t, all clean, $(addsuffix /$(t), $(ROM_DIRS)))
177 # Only keep -O and -g cflags
178 .PHONY: $(ROM_DIRS_RULES)
179 $(ROM_DIRS_RULES):
180 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $(dir $@) V="$(V)" TARGET_DIR="$(dir $@)" $(notdir $@),)
181
182 .PHONY: recurse-all recurse-clean
183 recurse-all: $(addsuffix /all, $(ROM_DIRS))
184 recurse-clean: $(addsuffix /clean, $(ROM_DIRS))
185
186 ######################################################################
187
188 clean: recurse-clean
189 -@test -f build.ninja && $(quiet-@)$(NINJA) $(NINJAFLAGS) -t clean || :
190 -@test -f build.ninja && $(NINJA) $(NINJAFLAGS) clean-ctlist || :
191 # avoid old build problems by removing potentially incorrect old files
192 rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
193 find . \( -name '*.so' -o -name '*.dll' -o -name '*.[oda]' \) -type f \
194 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-aarch64.a \
195 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-arm.a \
196 -exec rm {} +
197 rm -f TAGS cscope.* *.pod *~ */*~
198 rm -f fsdev/*.pod scsi/*.pod
199
200 VERSION = $(shell cat $(SRC_PATH)/VERSION)
201
202 dist: qemu-$(VERSION).tar.bz2
203
204 qemu-%.tar.bz2:
205 $(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"
206
207 distclean: clean
208 -@test -f build.ninja && $(quiet-@)$(NINJA) $(NINJAFLAGS) -t clean -g || :
209 rm -f config-host.mak config-host.h*
210 rm -f tests/tcg/config-*.mak
211 rm -f config-all-disas.mak config.status
212 rm -f tests/qemu-iotests/common.env
213 rm -f roms/seabios/config.mak roms/vgabios/config.mak
214 rm -f qemu-plugins-ld.symbols qemu-plugins-ld64.symbols
215 rm -f *-config-target.h *-config-devices.mak *-config-devices.h
216 rm -rf meson-private meson-logs meson-info compile_commands.json
217 rm -f Makefile.ninja Makefile.mtest
218 rm -f config.log
219 rm -f linux-headers/asm
220 rm -Rf .sdk
221
222 find-src-path = find "$(SRC_PATH)/" -path "$(SRC_PATH)/meson" -prune -o -name "*.[chsS]"
223
224 .PHONY: ctags
225 ctags:
226 rm -f "$(SRC_PATH)/"tags
227 $(find-src-path) -exec ctags -f "$(SRC_PATH)/"tags --append {} +
228
229 .PHONY: TAGS
230 TAGS:
231 rm -f "$(SRC_PATH)/"TAGS
232 $(find-src-path) -exec etags -f "$(SRC_PATH)/"TAGS --append {} +
233
234 .PHONY: cscope
235 cscope:
236 rm -f "$(SRC_PATH)"/cscope.*
237 $(find-src-path) -print | sed -e 's,^\./,,' > "$(SRC_PATH)/cscope.files"
238 cscope -b -i"$(SRC_PATH)/cscope.files" -f"$(SRC_PATH)"/cscope.out
239
240 # Needed by "meson install"
241 export DESTDIR
242
243 include $(SRC_PATH)/tests/docker/Makefile.include
244 include $(SRC_PATH)/tests/vm/Makefile.include
245
246 print-help-run = printf " %-30s - %s\\n" "$1" "$2"
247 print-help = $(quiet-@)$(call print-help-run,$1,$2)
248
249 .PHONY: help
250 help:
251 @echo 'Generic targets:'
252 $(call print-help,all,Build all)
253 $(call print-help,dir/file.o,Build specified target only)
254 $(call print-help,install,Install QEMU, documentation and tools)
255 $(call print-help,ctags/TAGS,Generate tags file for editors)
256 $(call print-help,cscope,Generate cscope index)
257 $(call print-help,sparse,Run sparse on the QEMU source)
258 @echo ''
259 ifeq ($(CONFIG_PLUGIN),y)
260 @echo 'Plugin targets:'
261 $(call print-help,plugins,Build the example TCG plugins)
262 @echo ''
263 endif
264 @echo 'Cleaning targets:'
265 $(call print-help,clean,Remove most generated files but keep the config)
266 $(call print-help,distclean,Remove all generated files)
267 $(call print-help,dist,Build a distributable tarball)
268 @echo ''
269 @echo 'Test targets:'
270 $(call print-help,check,Run all tests (check-help for details))
271 $(call print-help,bench,Run all benchmarks)
272 $(call print-help,docker,Help about targets running tests inside containers)
273 $(call print-help,vm-help,Help about targets running tests inside VM)
274 @echo ''
275 @echo 'Documentation targets:'
276 $(call print-help,html man,Build documentation in specified format)
277 @echo ''
278 ifdef CONFIG_WIN32
279 @echo 'Windows targets:'
280 $(call print-help,installer,Build NSIS-based installer for QEMU)
281 ifdef CONFIG_QGA_MSI
282 $(call print-help,msi,Build MSI-based installer for qemu-ga)
283 endif
284 @echo ''
285 endif
286 $(call print-help,$(MAKE) [targets],(quiet build, default))
287 $(call print-help,$(MAKE) V=1 [targets],(verbose build))
288
289 # will delete the target of a rule if commands exit with a nonzero exit status
290 .DELETE_ON_ERROR:
291
292 print-%:
293 @echo '$*=$($*)'